package org.apache.xindice.client.corba.db;

//
// Interface definition : Collection
//
// @author OpenORB Compiler
//
public interface CollectionOperations extends org.apache.xindice.client.corba.db.ServantManagementOperations
{
	//
	// Operation getName
	//
	public String getName()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation getCanonicalName
	//
	public String getCanonicalName()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation getCollectionManager
	//
	public org.apache.xindice.client.corba.db.CollectionManager getCollectionManager()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation getParentCollection
	//
	public org.apache.xindice.client.corba.db.Collection getParentCollection()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation listCollections
	//
	public String[] listCollections()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation getCollection
	//
	public org.apache.xindice.client.corba.db.Collection getCollection(String path)
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation insertDocument
	//
	public String insertDocument(String nam, org.apache.xindice.client.corba.db.EncodedBuffer doc)
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation removeDocument
	//
	public void removeDocument(String id)
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation getDocument
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer getDocument(String id, long stamp)
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation setDocument
	//
	public void setDocument(String id, org.apache.xindice.client.corba.db.EncodedBuffer doc)
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation getDocuments
	//
	public org.apache.xindice.client.corba.db.DocumentSet getDocuments()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation listDocuments
	//
	public String[] listDocuments()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation getDocumentCount
	//
	public int getDocumentCount()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation createNewOID
	//
	public String createNewOID()
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation queryCollection
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer queryCollection(String style, String query, org.apache.xindice.client.corba.db.NamedVal[] namespaces, long stamp)
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation queryDocument
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer queryDocument(String style, String query, org.apache.xindice.client.corba.db.NamedVal[] namespaces, String id, long stamp)
		throws org.apache.xindice.client.corba.db.APIException;

	//
	// Operation invokeXMLObject
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer invokeXMLObject(String uri)
		throws org.apache.xindice.client.corba.db.APIException;

}
