package org.apache.xindice.client.corba.db;

//
// Interface definition : Database
//
// @author OpenORB Compiler
//
public class DatabasePOATie extends DatabasePOA
{

	//
	// Private reference to implementation object
	//
	private DatabaseOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public DatabasePOATie( DatabaseOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public DatabasePOATie( DatabaseOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public DatabaseOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( DatabaseOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation getName
	//
	public String getName()
		throws org.apache.xindice.client.corba.db.APIException
	{
		return _tie.getName();
	}

	//
	// Operation getDatabaseManager
	//
	public org.apache.xindice.client.corba.db.DatabaseManager getDatabaseManager()
		throws org.apache.xindice.client.corba.db.APIException
	{
		return _tie.getDatabaseManager();
	}

	//
	// Operation listCollections
	//
	public String[] listCollections()
		throws org.apache.xindice.client.corba.db.APIException
	{
		return _tie.listCollections();
	}

	//
	// Operation getCollection
	//
	public org.apache.xindice.client.corba.db.Collection getCollection(String path)
		throws org.apache.xindice.client.corba.db.APIException
	{
		return _tie.getCollection( path);
	}

	//
	// Operation remove
	//
	public void remove()
	{
		_tie.remove();
	}

}
