package org.apache.xindice.client.corba.db;

//
// Interface definition : DocumentSet
//
// @author OpenORB Compiler
//
public class DocumentSetPOATie extends DocumentSetPOA
{

	//
	// Private reference to implementation object
	//
	private DocumentSetOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public DocumentSetPOATie( DocumentSetOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public DocumentSetPOATie( DocumentSetOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public DocumentSetOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( DocumentSetOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation hasMoreDocuments
	//
	public boolean hasMoreDocuments()
		throws org.apache.xindice.client.corba.db.APIException
	{
		return _tie.hasMoreDocuments();
	}

	//
	// Operation getNextDocument
	//
	public org.apache.xindice.client.corba.db.EncodedBuffer getNextDocument(long stamp)
		throws org.apache.xindice.client.corba.db.APIException
	{
		return _tie.getNextDocument( stamp);
	}

	//
	// Operation remove
	//
	public void remove()
	{
		_tie.remove();
	}

}
