package org.apache.xindice.client.corba.db;

//
// Interface definition : Database
//
// @author OpenORB Compiler
//
public class _DatabaseStub extends org.omg.CORBA.portable.ObjectImpl
		implements Database
{
	static final String[] _ids_list =
	{
		"IDL:org/apache/xindice/client/corba/db/Database:1.0", 
		"IDL:org/apache/xindice/client/corba/db/ServantManagement:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = org.apache.xindice.client.corba.db.DatabaseOperations.class;

	//
	// Operation getName
	//
	public String getName()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getName",true);
					_input = this._invoke(_output);
					String _arg_ret = _input.read_string();
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getName",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.DatabaseOperations _self = ( org.apache.xindice.client.corba.db.DatabaseOperations ) _so.servant;
				try
				{
					return _self.getName();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getDatabaseManager
	//
	public org.apache.xindice.client.corba.db.DatabaseManager getDatabaseManager()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getDatabaseManager",true);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.DatabaseManager _arg_ret = org.apache.xindice.client.corba.db.DatabaseManagerHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getDatabaseManager",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.DatabaseOperations _self = ( org.apache.xindice.client.corba.db.DatabaseOperations ) _so.servant;
				try
				{
					return _self.getDatabaseManager();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation listCollections
	//
	public String[] listCollections()
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("listCollections",true);
					_input = this._invoke(_output);
					String[] _arg_ret = org.apache.xindice.client.corba.db.NamesHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("listCollections",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.DatabaseOperations _self = ( org.apache.xindice.client.corba.db.DatabaseOperations ) _so.servant;
				try
				{
					return _self.listCollections();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation getCollection
	//
	public org.apache.xindice.client.corba.db.Collection getCollection(String path)
		throws org.apache.xindice.client.corba.db.APIException
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("getCollection",true);
					org.apache.xindice.client.corba.db.NameHelper.write(_output,path);
					_input = this._invoke(_output);
					org.apache.xindice.client.corba.db.Collection _arg_ret = org.apache.xindice.client.corba.db.CollectionHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.apache.xindice.client.corba.db.APIExceptionHelper.id()) )
					{
						throw org.apache.xindice.client.corba.db.APIExceptionHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getCollection",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.DatabaseOperations _self = ( org.apache.xindice.client.corba.db.DatabaseOperations ) _so.servant;
				try
				{
					return _self.getCollection( path);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation remove
	//
	public void remove()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("remove",true);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("remove",_opsClass);
				if ( _so == null )
				   continue;
				org.apache.xindice.client.corba.db.ServantManagementOperations _self = ( org.apache.xindice.client.corba.db.ServantManagementOperations ) _so.servant;
				try
				{
					_self.remove();
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
