package org.apache.xindice.client.corba.db;

//
// Interface definition : Database
//
// @author OpenORB Compiler
//
public abstract class DatabasePOA extends org.omg.PortableServer.Servant
		implements DatabaseOperations, org.omg.CORBA.portable.InvokeHandler
{
	public Database _this()
	{
		return DatabaseHelper.narrow(_this_object());
	}

	public Database _this( org.omg.CORBA.ORB orb )
	{
		return DatabaseHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:org/apache/xindice/client/corba/db/Database:1.0", 
		"IDL:org/apache/xindice/client/corba/db/ServantManagement:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("getName") )
		{

			try
			{
				String _arg_result = getName();

				_output = handler.createReply();
				_output.write_string(_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("getDatabaseManager") )
		{

			try
			{
				org.apache.xindice.client.corba.db.DatabaseManager _arg_result = getDatabaseManager();

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.DatabaseManagerHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("listCollections") )
		{

			try
			{
				String[] _arg_result = listCollections();

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.NamesHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("getCollection") )
		{
			String arg0_in = org.apache.xindice.client.corba.db.NameHelper.read(_is);

			try
			{
				org.apache.xindice.client.corba.db.Collection _arg_result = getCollection(arg0_in);

				_output = handler.createReply();
				org.apache.xindice.client.corba.db.CollectionHelper.write(_output,_arg_result);

			}
			catch ( org.apache.xindice.client.corba.db.APIException _exception )
			{
				_output = handler.createExceptionReply();
				org.apache.xindice.client.corba.db.APIExceptionHelper.write(_output,_exception);
			}
			return _output;
		}
		else
		if ( opName.equals("remove") )
		{

			remove();

			_output = handler.createReply();

			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
